/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   extra.h                                            :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: cchauvet <cchauvet@student.42angouleme.fr  +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2023/01/04 14:03:10 by cchauvet          #+#    #+#             */
/*   Updated: 2023/05/03 11:02:33 by cchauvet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef EXTRA_H
# define EXTRA_H
# include <stdarg.h>
# include <stdlib.h>
#include <sys/types.h>
# include <unistd.h>
# include <fcntl.h>
# include "../libft/libft.h"

unsigned long	ft_atoul(const char str[]);
int				ft_atoul_check(const char str[]);
size_t			ft_tablen(const void **tab);
char			*ft_ultoa_base(unsigned long long n, char *base);
char			*get_next_line(int fd);
size_t			ft_random_generator(size_t start, size_t stop);
void			ft_freer_tab_ultimate(size_t len, ...);
void			ft_freer_ultimate(size_t len, ...);
char			*ft_strgen(char c, size_t len);
char			*ft_strfjoin(char *s1, char *s2);
char			*ft_strmerger(size_t arg_len, ...);
int				ft_is_in(const char *str, char c);
char			**ft_tabrealloc(char **tab, size_t current_size, size_t new_size);
char			*ft_strndup(const char *src, size_t n);
ssize_t			ft_strchri(char *str, char c);
int				ft_contain_only_str(const char *str, const char *to_find);
int				ft_contain_only(const char *str, char c);
int				ft_strcmp(const char *s1, const char *s2);
void			ft_swap(void *a, void *b);
void			ft_swap_int(int *a, int *b);
void			ft_swap_char(char *a, char *b);

#endif
